' Game written by Vincent Erickson
' Published bye Creative Computing Magazine, and the the David Ahl books.

' Copyright 1979, 1980, 2011

Const buildversion = "20 Release Candidate 3"
Const builddate = "06/14/11"

#Include "fbgfx.bi"
#if __FB_LANG__ = "fb"
Using FB '' Screen mode flags are in the FB namespace in lang FB
#EndIf

#Include "fmod.bi"
#include "windows.bi"
#include "win/shellapi.bi"
#Include "freeimage.bi"
#include "crt.bi"
#Include "vbcompat.bi"
#Include "file.bi"
#Include "xfont.bi"

#Include ".\inc\declare.bi"
#Include ".\inc\variables.bi"
#Include ".\inc\sound.bi"

loadconfig

If startupres="1280X768" Then
	If fullscreen=0 Then
		ScreenRes 1280,768,32,2,GFX_WINDOWED
		Width 1280/8,768/16
	Else
		ScreenRes 1280,768,32,2,GFX_FULLSCREEN
		Width 1280/8,768/16
	EndIf
EndIf

If startupres="1280X1024" Then
	If fullscreen=0 Then
		ScreenRes 1280,1024,32,2,GFX_WINDOWED
		Width 1280/8,1024/16
	Else
		ScreenRes 1280,1024,32,2,GFX_FULLSCREEN
		Width 1280/8,1024/16
	EndIf
EndIf

If startupres="1366X768" Then
	If fullscreen=0 Then
		ScreenRes 1366,768,32,2,GFX_WINDOWED
		Width 1368/8,768/16
	Else
		ScreenRes 1366,768,32,2,GFX_FULLSCREEN
		Width 1368/8,768/16
	EndIf
EndIf

If startupres="1280X800" Then
	If fullscreen=0 Then
		ScreenRes 1280,800,32,2,GFX_WINDOWED
		Width 1280/8,800/16
	Else
		ScreenRes 1280,800,32,2,GFX_FULLSCREEN
		Width 1280/8,800/16
	EndIf
EndIf


refreshview ("")

Color RGB(255,255,255),RGB(0,0,0)
WindowTitle ("Sea Battle 2.0 FB - Build # "+Str(buildversion)+" Build Date "+Builddate)

#Include ".\inc\commands.bi"
#Include ".\inc\startup.bi"
#Include ".\inc\version2.bi"
 
Cls
If musicvol>0 Then playStreamMusic (".\sound\music\At_Launch.ogg")

refreshview("FULL")
Put (0,0),titlescreen,PSet
refreshview("")

ScreenLock
font.backcolor = RGBA(255,0,255,0)
font.forecolor = Rgba(255,255,255,255)
font.fontindex = 2
font.drawstring (,"Sea Battle 2.0",63+fontx,51+fonty)
font.fontindex = 1
font.drawstring (,"Copyright 1979, 1980, 2011",901+fontx,201+fonty)
font.forecolor = Rgba(0,0,0,255)
font.drawstring (,"Originally written by Vincent Erickson",361+fontx,301+fonty)
font.drawstring (,"Updated by Steve North",471+fontx,361+fonty)
font.drawstring (,"Rewritten and updated by John Riggle",368+fontx,601+fonty)
font.drawstring (,"Originally published by:",471+fontx,671+fonty)
font.drawstring (,"Creative Computing  Morristown, New Jersey",317+fontx,701+fonty)

font.forecolor = Rgba(0,0,0,255)
font.fontindex = 2
font.drawstring (,"Sea Battle 2.0",62+fontx,50+fonty)
font.fontindex = 1
font.drawstring (,"Copyright 1979, 1980, 2011",900+fontx,200+fonty)
font.forecolor = Rgba(255,255,255,255)
font.drawstring (,"Originally written by Vincent Erickson",360+fontx,300+fonty)
font.drawstring (,"Updated by Steve North",470+fontx,360+fonty)
font.drawstring (,"Rewritten and updated by John Riggle",367+fontx,600+fonty)
font.drawstring (,"Originally published by:",470+fontx,670+fonty)
font.drawstring (,"Creative Computing  Morristown, New Jersey",316+fontx,700+fonty)

Put (30,700), button, Trans
Put (1090,700), button, trans
font.fontindex = 1
font.forecolor = Rgba(0,0,0,255)
font.drawstring (,"New Game",41+fontx,708+fonty)
font.drawstring (,"Options",1116+fontx,708+fonty)
font.forecolor = Rgba(255,255,255,255)
font.drawstring (,"New Game",40+fontx,707+fonty)
font.drawstring (,"Options",1115+fontx,707+fonty)
ScreenUnLock

programexit=0

Do
	tempstring=KeyStroke(1)
	If tempstring="^EXIT" Then program_exit
	If ucase(tempstring) ="O" Then 
		options
		TEMPSTRING=""
	EndIf
	If tempstring=Chr(27) Then program_exit
Loop Until UCase(tempstring)="N"

stopStreamMusic()
font.fontindex = 4
font.forecolor = Rgba(0,0,0,255)
Cls
playing=1
If musicvol>0 Then playStreamMusic (".\sound\music\Machinations.ogg")
playing=1
refreshview("FULL")
Put (0,0),desk1,PSet
refreshview("")
font.drawstring(,"Press any key to open your orders.",700+fontx,700+fonty)
tempstring=keystroke(2)
If tempstring="^EXIT" Then program_exit

refreshview("FULL")
Put (0,0),desk2,PSet
refreshview("")
font.drawstring(,"What is your name for the log, Captain?",650+fontx,75+fonty)
namestring=GetString(650,120,0,7,20,"")
If Namestring ="^EXIT" Then program_exit
If namestring ="^ABORT" Or namestring=Chr(13) Then
	If soundvol>0 Then playsample(buttons(3))
	namestring=""
EndIf
If namestring="" Then
	i=Int(Rnd*13)+1
	Select Case As Const I
		Case 1
			namestring="Ahab"
		Case 2
			namestring="Kirk"
		Case 3
			namestring="Cook"
		Case 4
			namestring="Nemo"
		Case 5
			namestring="Bligh"
		Case 6
			namestring="Drake"
		Case 7
			namestring="Picard"
		Case 8
			namestring="Magellan"
		Case 9
			namestring="Sparrow"
		Case 10
			namestring="Nelson"
		Case 11
			namestring="Perry"
		Case 12
			namestring="Pike"
		Case Else
			namestring="Morgan"
	End Select
EndIf
namestring="Captain "+namestring 

Do 
	If playing=0 and musicvol>0 Then playStreamMusic (".\sound\music\Machinations.ogg")
	
	gamesettings ()
	playing=0
	gameinit
	gameexit=0
	displayconsole("RESET")
	displaymainconsole("RESET")
	stopStreamMusic()
	firstscan=1	

	Do 
		If musicvol>0 Then playStreamMusicloop (".\sound\sfx\hum.ogg")
		displaybridge
		displaybuttons(1)
		displayconsole ("What are your orders "+namestring+"?")
		commandflag=0
		Do
			tempstring=KeyStroke(3)
			If tempstring="^EXIT" then program_exit
			If tempstring="^UP" Then displayconsole ("UP")
			If tempstring="^DOWN" Then displayconsole ("DOWN")
			If tempstring="^PGUP" Then displaymainconsole("UP")
			If tempstring="^PGDN" Then displaymainconsole("DOWN")
			If tempstring="W" Then
				Put (740,488),buttonwipe,PSet
				commandflag=1
				enemymove				
			EndIf
			If TEMPSTRING ="O" Then options
			If TEMPSTRING = "H" Then help
			If Len(tempstring)=1 And Asc(tempstring)>47 And Asc(tempstring)<58 Then
				Put (740,488),buttonwipe,PSet
				orders=Val(tempstring)
				commandflag=1
				Select Case As Const orders
					Case 0 
						displayconsole("Navigation, aye sir.")
						navigation
					Case 1
						displayconsole("Sonar room reporting, aye sir.")
						sonar2
					Case 2
						displayconsole("Torpedo room reporting in, aye sir.")
						torpedocontrol
					Case 3
						displayconsole("Polaris Missile control reporting in, aye sir.")
						polarismisslecontrol
					Case 4
						displayconsole("Manuervering, aye sir.")
						manuervering
					Case 5
						displayconsole("Status report, aye sir.")
						statusdamagereport
					Case 6
						displayconsole("Aye sir, calling headquarters.")
						headquarters
					Case 7
						displayconsole("Aye sir, sabotage.")
						sabotage
					Case 8
						displayconsole("Power converter, aye sir.")
						powerconversion
					Case 9
						displayconsole("Surfacing, broadcasting our surrender.")
						surrender
				End Select
			EndIf
		Loop Until (commandflag=1)
		
	Loop Until (gameexit=1)

	displaymainconsole (" ")
	displaymainconsole ("Want another game?")
	displaybuttons(3)
	tempstring=KeyStroke(5)
	If tempstring="^EXIT" Then program_exit
	If uCase(LEFT(tempstring,1))<>"Y" Then programexit=1

Loop Until (programexit=1)

program_exit

Data "   ","***",">V<","<R>","!H!"," $ ","-#-"
Data "Engines","Sonar","Torpedoes","Missles","Manuevering"
Data "Status","Headquarters","Sabotage","Converter"
Data -1,0,-1,1,0,1,1,1,1,0,1,-1,0,-1,-1,-1
Data 0,1,1,1,0,0,0,1,1,1,1,0,1,1,1,0,1,1,1,1,0,0,0,1 
Data 1,1,0,0,1,1,0,1,1,0,1,0,0,0,1,0,0,0

